/*****************************************************************************/
/* main.h : Donnes globales et fentre principale
 * main.h : Global data and main window
 *
 *
 * Greffon ToutDoux : signets
 * ToutDoux's plug-in : bookmarks
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@yahoo.com>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/

#include <toutdoux.h>


/*****************************************************************************/
/* Variables globales */
/*****************************************************************************/
GtkObject *mod; /* Module */
GtkObject *flower[3]; /* Fichier support */

/*****************************************************************************/
/* Module */
/*****************************************************************************/
GtkObject *plugins_about_def (void);
void mod_about (void);
GtkObject *mod_def (void);
void plugins_init (int mod_id);
void plugins_show (void);
void plugins_hide (void);
void plugins_destroy (void);
void plugins_custom (void);

/*****************************************************************************/
/* Proprits */
/*****************************************************************************/
void prop_favorite_name (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_interface (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_host (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_port (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_base (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_user (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_password (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_template (GtkWidget *widget, GtkObject *mod_tree);
void prop_favorite_location (GtkWidget *widget, GtkObject *mod_tree);
void prop_template_name (GtkWidget *widget, GtkObject *mod_tree);
void prop_template_location (GtkWidget *widget, GtkObject *mod_tree);

/*****************************************************************************/
/* Menus */
/*****************************************************************************/
void menu_new_file (GtkMenuItem *menuitem, gpointer user_data);
void menu_remove_file (GtkMenuItem *menuitem, gpointer user_data);
void menu_new_template (GtkMenuItem *menuitem, gpointer user_data);
void menu_remove_template (GtkMenuItem *menuitem, gpointer user_data);

/*****************************************************************************/
/* Barre d'outils */
/*****************************************************************************/
void radiobutton1_clicked (GtkRadioButton *radiobutton, gpointer *user_data);
void radiobutton2_clicked (GtkRadioButton *radiobutton, gpointer *user_data);
void radiobutton3_clicked (GtkRadioButton *radiobutton, gpointer *user_data);

/*****************************************************************************/
/* Fichier */
/*****************************************************************************/
void save_data (void);
void load_data (void);

/*****************************************************************************/
/* Menus de la palette */
/*****************************************************************************/
void menu_add (GtkObject *flower, gchar *path_init, int type_field);
GtkObject *plugins_menu_activate (gchar *number);
void plugins_add_recents (GtkObject *connect);
