/*****************************************************************************/
/* td_mod_tree_menu.h : Objet Gtk+
 * td_mod_tree_menu.h : Gtk+ object
 *
 *
 * ToutDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@yahoo.com>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>


/*****************************************************************************/
/* Macros */
/*****************************************************************************/
#define TD_TYPE_MOD_TREE_MENU (td_mod_tree_menu_get_type ())
#define TD_MOD_TREE_MENU(obj) (GTK_CHECK_CAST ((obj), TD_TYPE_MOD_TREE_MENU, TdModTreeMenu))
#define TD_MOD_TREE_MENU_CLASS(klass) (GTK_CHECK_CLASS_CASTS ((klass), TD_TYPE_MOD_TREE_MENU, TdModTreeMenuClass))
#define TD_IS_MOD_TREE_MENU(obj) (GTK_CHECK_TYPE ((obj), TD_TYPE_MOD_TREE_MENU))
#define TD_IS_MOD_TREE_MENU_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), TD_TYPE_MOD_TREE_MENU))

/*****************************************************************************/
/* Structure */
/*****************************************************************************/
typedef struct _TdModTreeMenu TdModTreeMenu;
typedef struct _TdModTreeMenuClass TdModTreeMenuClass;

struct _TdModTreeMenu
{
  GtkObject object;
  GtkWidget *menu;
  GList *equal;
};

struct _TdModTreeMenuClass
{
  GtkObjectClass parent_class;
  void (*set) (TdModTreeMenu *mod_tree_menu, GtkWidget *menu);
  void (*add_equal) (TdModTreeMenu *mod_tree_menu, GtkObject *equal);
};

/*****************************************************************************/
/* Arguments */
/*****************************************************************************/

/*****************************************************************************/
/* Initialisation */
/*****************************************************************************/
static void td_mod_tree_menu_init (TdModTreeMenu *mod_tree_menu);
static void td_mod_tree_menu_class_init (TdModTreeMenuClass *klass);
GtkType td_mod_tree_menu_get_type (void);
GtkObject *td_mod_tree_menu_new (void);

/*****************************************************************************/
/* Affectations */
/*****************************************************************************/
void td_mod_tree_menu_set (TdModTreeMenu *mod_tree_menu, GtkWidget *menu);
void td_mod_tree_menu_add_equal (TdModTreeMenu *mod_tree_menu, GtkObject *equal);

/*****************************************************************************/
/* Commandes */
/*****************************************************************************/



